#include <vcl.h>
#pragma hdrstop

#include "main.h"
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

void Calendar (void);
Word GetWeekDay1 (Word Y, Word M);
void  UpdateCalendar (Word AYear,Word AMonth, Word ADay, Word WeekDay1);
bool LeapYear(Word AYear);
Word DaysPerMonth(Word AYear, Word AMonth);

bool LeapYear(Word AYear) { //  
  return  ((AYear %   4) == 0) &&
         (((AYear % 100) != 0) ||
          ((AYear % 400) == 0));
};

Word DaysPerMonth(Word AYear, Word AMonth) {
 //    
  int result;
  int DaysInMonth[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
  result = DaysInMonth[AMonth-1];
  if ((AMonth == 2) && LeapYear(AYear)) ++result;
  return result;
};

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner) {
}

void __fastcall TForm1::Button3Click(TObject *Sender)
{ // 
 Form1->Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ // 
 Form1->Memo1->Visible=true;
 Form1->StringGrid1->Visible=false;
 Form1->Memo1->Lines->Clear();
 Form1->Memo1->Lines->Add (" \r\n"
 "  -  ,       "
 "    \r\n"
 "           \r\n"
 "       ,  "
 "    .\r\n"
 "   C++ Bulider 5.  - PerS, 2002 .");
}

void Calendar (void) {
//  -     
 const char *Mon[13] = { "",
 "", "", "", "", "", "",
 "", "", "", "", "", "" };
 Word  AYear, AMonth, ADay;
 TDateTime FDate;
 FDate = Date();
 DecodeDate(FDate, AYear, AMonth, ADay);
 Form1->Label3->Caption=" "+ IntToStr(ADay) + " "+
  Mon[AMonth] + " "+ IntToStr (AYear) + " .";
 AYear=Form1->ScrollBar1->Position;
 Form1->Label1->Caption=": "+IntToStr(Form1->ScrollBar1->Position);
 AMonth=Form1->ComboBox1->ItemIndex+1;
 Word WeekDay1=GetWeekDay1 (AYear, AMonth);
 UpdateCalendar (AYear,AMonth,ADay,WeekDay1-1);
 Form1->Memo1->Visible=false;
 Form1->StringGrid1->Visible=true;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender) {
 //  -     
 Word  AYear, AMonth, ADay;
 TDateTime FDate;
 FDate = Date();
 DecodeDate(FDate, AYear, AMonth, ADay);
 Word WeekDay1=GetWeekDay1 (AYear, AMonth);
 Form1->ScrollBar1->Position=AYear;
 Form1->ComboBox1->ItemIndex=AMonth-1;
 Form1->Memo1->Visible=false;
 Form1->StringGrid1->Visible=true;
 UpdateCalendar (AYear,AMonth,ADay,WeekDay1-1);
}

void  UpdateCalendar (Word AYear,Word AMonth,Word ADay, Word WeekDay1) {
 //  -  
 const char *WeekDays[7] = {"", "", "", "", "", "", ""};
 Word High=DaysPerMonth (AYear,AMonth);
 Word Count=1;
 int I,J;
 for (J=0; J< 8; J++)    //
 for (I=0; I< 7; I++) {  //
  if (Count==ADay) { //    =
   TGridRect S;
   S.Left=I; S.Right=I; S.Bottom=J; S.Top=J;
   Form1->StringGrid1->Selection=S;
  }
  if (J==0) { Form1->StringGrid1->Cells[I][J]=WeekDays[I];  }
  else {
   if (J==1) {
    if (I<WeekDay1)Form1->StringGrid1->Cells[I][J]="";
    else {
     Form1-> StringGrid1->Cells[I][J]=IntToStr(Count);
     Count++;
    }
   }
   else {
    if (Count>High) {
     Form1->StringGrid1->Cells[I][J]="";
    }
    else {
     Form1-> StringGrid1->Cells[I][J]=IntToStr(Count);
    }
    Count++;
   }
  }
 }
}

Word GetWeekDay1 (Word Y, Word M) {
 //  -     1-    
 if (M < 3){ M+=12 ; Y-- ; }
 int n1,n2;
 n1 = (26 * (M + 1)) / 10 ;
 n2 = (int) ((125 * (long) Y) / 100) ;
 int day = ((1 + n1 + n2 - (Y / 100) + (Y / 400) -1) % 7) ;
 if (day==0) day=7;
 return day;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender){
 // 
 Word  AYear, AMonth, ADay;
 TDateTime FDate;
 FDate = Date();
 DecodeDate(FDate, AYear, AMonth, ADay);
 Form1->  ScrollBar1->Position = AYear;
 Form1->Label1->Caption=": "+ IntToStr(ScrollBar1->Position);
 Form1->ComboBox1->ItemIndex=AMonth-1;
 Form1->Button1Click(Form1);
 Calendar();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender){
//   
 Calendar();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{ // 
 Calendar();
}
//---------------------------------------------------------------------------

